Subject: Re: linux-next: build failure after merge of the net-next tree

From: Nathan Chancellor <[email-masked]>
Date: Wed, 23 Jun 2021 19:29:11 -0700

On Thu, Jun 24, 2021 at 12:46:48AM +0200, Marcin Wojtas wrote:
> Hi Stephen,
> 
> czw., 24 cze 2021 o 00:29 Stephen Rothwell <[email-masked]> napisał(a):
> >
> > Hi all,
> >
> > Today's linux-next build (x86_64 modules_install) failed like this:
> >
> > depmod: ../tools/depmod.c:1792: depmod_report_cycles_from_root: Assertion `is < stack_size' failed.
> >
> > Caused by commit
> >
> > 62a6ef6a996f ("net: mdiobus: Introduce fwnode_mdbiobus_register()")
> >
> > (I bisected to there and tested the commit before.)
> >
> > The actual build is an x86_64 allmodconfig, followed by a
> > modules_install.  This happens in my cross build environment as well as
> > a native build.
> >
> > $ gcc --version
> > gcc (Debian 10.2.1-6) 10.2.1 20210110
> > $ ld --version
> > GNU ld (GNU Binutils for Debian) 2.35.2
> > $ /sbin/depmod --version
> > kmod version 28
> > -ZSTD +XZ -ZLIB +LIBCRYPTO -EXPERIMENTAL
> >
> > I have no idea why that commit should caused this failure.
> 
> Thank you for letting us know. Not sure if related, but I just found
> out that this code won't compile for the !CONFIG_FWNODE_MDIO. Below
> one-liner fixes it:
> 
> --- a/include/linux/fwnode_mdio.h
> +++ b/include/linux/fwnode_mdio.h
> @@ -40,7 +40,7 @@ static inline int fwnode_mdiobus_register(struct mii_bus *bus,
>          * This way, we don't have to keep compat bits around in drivers.
>          */
> 
> -       return mdiobus_register(mdio);
> +       return mdiobus_register(bus);
>  }
>  #endif
> 
> I'm curious if this is the case. Tomorrow I'll resubmit with above, so
> I'd appreciate recheck.

I wonder if this message that I see with Arch Linux's config is related
and maybe explains the issue a little bit more:

$ curl -LSso .config https://raw.githubusercontent.com/archlinux/svntogit-packages/packages/linux/trunk/config

# do not require pahole
$ scripts/config -d DEBUG_INFO_BTF

$ make -skj"$(nproc)" INSTALL_MOD_PATH=rootfs olddefconfig all modules_install
...
depmod: ERROR: Cycle detected: acpi_mdio -> fwnode_mdio -> acpi_mdio
depmod: ERROR: Found 2 modules in dependency cycles!
...

Reverting all the patches in that series fixes the issue for me.

Cheers,
Nathan